package infomat.vectorspace.weighting;

import infomat.vectorspace.*;

import mro.util.*;
import mro.util.properties.*;

import java.lang.Math.*;
import java.util.*;

/**
 * A class for weighting of a IMatrix. Sets the weight for each cell
 * to the local count.
 *
 * @version          080825
 * @author           Magnus Rosell
 */
public class CountWeighter extends Weighter{

    public CountWeighter(){
	super();
    }

    public CountWeighter(mro.util.properties.Properties properties){
	super(properties);
    }

    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = new mro.util.properties.Properties("Count Weighter Properties", CurrentClassGetter.getClassName());

	/*		
	try{

	    // Local row weight
	    Property p = new Property("Dimension", 0, "Rows or Columns");
	    PropertyValueDescription pvd = new PropertyValueDescription(0, "Rows.");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription(1, "Columns.");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	*/

	return properties;
    }

    public Object getPropertyValue(String name){
	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) 
	throws PropertyNotFoundException{
	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
	this.properties=properties;
    }

    public String getWeighterName(){
	return "Count-Weighter";
    }


    /**
     * Weight the IMatrix (the whole matrix, 
     * which may be more than the current IObjectGroupings, the picture).
     */
    public void weight(IMatrix matrix){ 

	Vector cellVec = matrix.getAllCells();
	for(int i=0; i<cellVec.size(); i++){
	    IMatrixCell mc = (IMatrixCell) cellVec.get(i);
	    mc.setWeight(mc.getLocalCount());
	}

	/*
	int rowsOrColumns = (Integer) getPropertyValue("Dimension");
	IObjectSet set = matrix.getRowIObjectSet();
	if(rowsOrColumns==1)
	    set = matrix.getColumnIObjectSet();

	Vector<IObject> ioVec = set.getOrdered();
	for(int i=0; i<ioVec.size(); i++){
	    IObject io = ioVec.get(i);
	    Vector cellVec = getCellsWith(io);
	    float totalCount = 0.0f;
	    for(int j=0; j<cellVec.size(); j++){
		IMatrixCell mc = (IMatrixCell) cellVec.get(j);
		totalCount += mc.getLocalCount();
	    }
	    for(int j=0; j<cellVec.size(); j++){
		IMatrixCell mc = (IMatrixCell) cellVec.get(j);
		mc.setWeight(mc.getLocalCount());
	    }
	}
	*/
    }
}
