package infomat.view.grouping.settings;

import infomat.vectorspace.*;

public class GroupingSettings {
	private IObjectGrouping grouping;
	private boolean row;

	private float minOpacity;
	private float maxOpacity;
	private float oldMinOpacity;
	private float oldMaxOpacity;

	private GroupingColoring coloring=null;
	private GroupingColoring oldColoring=null;
	
	/*
	private float colorMinOpacity = 0.1f;
	private float colorMaxOpacity = 0.5f;
	private float oldColorMinOpacity = 0.1f;
	private float oldColorMaxOpacity = 0.5f;
	 */
	
	public GroupingSettings(IObjectGrouping grouping, boolean row){
		this.grouping=grouping;
		this.row=row;
		resetOpacities();
	}
	
	public float getMinOpacity(){
		return minOpacity;
	}

	public float getMaxOpacity(){
		return maxOpacity;
	}

	public void setMinOpacity(float minOpacity){
		if(minOpacity>this.maxOpacity)
			minOpacity=this.maxOpacity;
		this.oldMinOpacity=this.minOpacity;
		this.minOpacity=minOpacity;
	}
	
	public void setMaxOpacity(float maxOpacity){
		if(maxOpacity<this.minOpacity)
			maxOpacity=this.minOpacity;
		this.oldMaxOpacity=this.maxOpacity;
		this.maxOpacity=maxOpacity;
	}
	
	public void resetOpacities(){
		if(row){
			minOpacity = 0.5f;
			maxOpacity = 1.0f;
			oldMinOpacity = 0.5f;
			oldMaxOpacity = 1.0f;
		}else{
			minOpacity = 0.1f;
			maxOpacity = 0.4f;
			oldMinOpacity = 0.1f;
			oldMaxOpacity = 0.4f;
		}
		/*
		colorMinOpacity = 0.1f;
		colorMaxOpacity = 0.5f;
		oldColorMinOpacity = 0.1f;
		oldColorMaxOpacity = 0.5f;
		*/
	}
	
	public boolean opacityChanged(){
		if(minOpacity!=oldMinOpacity)
			return true;
		if(maxOpacity!=oldMaxOpacity)
			return true;
		return false;
	}

	/*
	public boolean colorOpacityChanged(){
		if(colorMinOpacity!=oldColorMinOpacity)
			return true;
		if(colorMaxOpacity!=oldColorMaxOpacity)
			return true;
		return false;
	}
	*/
	
	public void setOpacity(){
		oldMinOpacity=minOpacity; 
		oldMaxOpacity=maxOpacity; 
	}
	
	public boolean coloringChanged(){
		if(coloring==oldColoring)
			return false;
		return true;
	}
	
	public void setColoring(GroupingColoring coloring){
		this.oldColoring=this.coloring;
		this.coloring=coloring;
	}
	
	public GroupingColoring getColoring(){
		return coloring;
	}
	
}
