package infomat.view.info;

import infomat.view.*;
import infomat.view.picture.*;
import infomat.vectorspace.*;

import java.awt.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.TitledBorder;

public class DimensionInfoPanel extends JPanel
    implements Observer{

    private InfomatModel model;
    private InfomatView view;
    private boolean row;

    private static String noGroup=" ";
    private InfoLabel groupLabel;
	
    private static String noObject=" ";
    private InfoLabel objectLabel;

    private TitledBorder titleBorder;
	
    public final static int DIMENSIONINFOPANLE_PREFERRED_HEIGHT=60;
	
    public DimensionInfoPanel(InfomatModel model, InfomatView view, boolean row){
	this.model=model;
	this.view = view;
	this.row=row;
	model.addObserver(this);
		
		
		
	titleBorder = new TitledBorder("");
	setBorder(titleBorder);
		
	makeTitle();
	putAll();
	repaint();
    }
	
    private void makeTitle(){
	String title = view.getColumnDimensionName();
	if(model.getIMatrix()!= null){
	    IObjectSet colCOS = model.getIMatrix().getColumnIObjectSet();
	    title+=" ("+colCOS.getString()+")";
	}
	if(row){
	    title = view.getRowDimensionName();
	    if(model.getIMatrix()!= null){
		IObjectSet rowCOS = model.getIMatrix().getRowIObjectSet();
		title+=" ("+rowCOS.getString()+")";
	    }
	}
	titleBorder.setTitle(title);
    }
	
	
    public void putAll(){
	removeAll();
	objectLabel = new InfoLabel("Object");
	add(objectLabel);
	groupLabel = new InfoLabel("Group ");
	add(groupLabel);
    }
	
    public void setCurrentInfo(IObject io){ //SparsePixel sp){
	objectLabel.setText(noObject);
	groupLabel.setText(noGroup);
	if(io!=null){
	    objectLabel.setText(io.getString());
			
	    if(model.getIMatrix()!= null){
		if(row){
		    IObjectGrouping rowGrouping = 
			model.getGUIIMatrix().getCurrentRowGrouping();

		    IObjectGroup rowGroup = rowGrouping.inWhichIObjectGroup(io);
		    if(rowGroup!=null)
			groupLabel.setText(rowGroup.getString());
		}else{
		    IObjectGrouping colGrouping = 
			model.getGUIIMatrix().getCurrentColumnGrouping();
		    IObjectGroup colGroup = colGrouping.inWhichIObjectGroup(io);
		    if(colGroup!=null)
			groupLabel.setText(colGroup.getString());
		}
	    }
	}
	repaint();
		
	/*
	  objectLabel.setText(noObject);
	  if(sp!=null){
	  //IMatrix matrix = model.getIMatrix();
	  IMatrixCell mc = sp.getIMatrixCellWithHighestWeight();
	  if(mc!=null){
	  IObject io = mc.getColumnIObject();
	  if(row)
	  io = mc.getRowIObject();
	  objectLabel.setText(io.getString());
	  }
	  }
	*/
    }
	
    public void update(Observable o, Object arg) {
	makeTitle();
	repaint();
    }
	
    public void paintComponent(Graphics g){
	super.paintComponent(g);
    }
	
	
    protected class InfoLabel extends JLabel{
	private String title;
		
	public InfoLabel(String title){
	    this.title=title;
	    setText("");
	}
		
	public void setText(String text){
	    super.setText(title+": "+text);
	}
		
    }
	
	
}
